﻿
// DNGConverterDlg.cpp : 구현 파일
//

#include "stdafx.h"
#include "afxdialogex.h"
#include "DNGConverter.h"
#include "DNGConverterDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 응용 프로그램 정보에 사용되는 CAboutDlg 대화 상자입니다.

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 대화 상자 데이터입니다.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 지원입니다.

// 구현입니다.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// CDNGConverterDlg 대화 상자

CDNGConverterDlg::CDNGConverterDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDNGConverterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	CTime t= CTime::GetCurrentTime();
	saveFileName.Format(_T("%02d%02d.dng"),t.GetMonth(), t.GetDay());
	threadRun = false;
	snd.state = STATE_UNABLE;
	
	//language 설정
	language = (0xff& GetSystemDefaultLangID());
	LANGID compChinese = GetSystemDefaultLangID(); 

	//LANG_CHINESE_TRADITIONAL 번체 0x404 0x1404 0xc04 간체 0x804 0x1004									

	if(language == LANG_KOREAN)
	{
		//do nothing..
	}	
	else if(language == LANG_FRENCH)
	{
		HINSTANCE hInstance = AfxGetResourceHandle();  
		if(hInstance != NULL)
			FreeLibrary(hInstance);

		HMODULE hModule = LoadLibrary(_T("MultiLangFre.dll"));
		if(hModule != NULL)
			AfxSetResourceHandle( hModule );

		//SetThreadLocale( MAKELCID( MAKELANGID(LANG_ENGLISH , SUBLANG_ENGLISH_US) , SORT_DEFAULT)); 
	}
	else if(language == LANG_CHINESE )
	{
		if( compChinese == 0x804 || compChinese == 0x1004)
		{
			HINSTANCE hInstance = AfxGetResourceHandle();  
			if(hInstance != NULL)
				FreeLibrary(hInstance);

			HMODULE hModule = LoadLibrary(_T("MultiLangChn.dll"));
			if(hModule != NULL)
				AfxSetResourceHandle( hModule );
		}
		else
		{
			HINSTANCE hInstance = AfxGetResourceHandle();  
			if(hInstance != NULL)
				FreeLibrary(hInstance);

			HMODULE hModule = LoadLibrary(_T("MultiLangEng.dll"));
			if(hModule != NULL)
				AfxSetResourceHandle( hModule );
		}

		//SetThreadLocale( MAKELCID( MAKELANGID(LANG_ENGLISH , SUBLANG_ENGLISH_US) , SORT_DEFAULT)); 
	}
	else
	{
		HINSTANCE hInstance = AfxGetResourceHandle();  
		if(hInstance != NULL)
			FreeLibrary(hInstance);

		HMODULE hModule = LoadLibrary(_T("MultiLangEng.dll"));
		if(hModule != NULL)
			AfxSetResourceHandle( hModule );

		//SetThreadLocale( MAKELCID( MAKELANGID(LANG_ENGLISH , SUBLANG_ENGLISH_US) , SORT_DEFAULT)); 
	}
	//language 설정 끝
}

void CDNGConverterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_fileList);
	DDX_Control(pDX, IDC_EDIT1, m_savePath);
	DDX_Control(pDX, IDC_FILE_LIST, m_fileListText);
	DDX_Control(pDX, IDC_FILE_SELECT, m_fileAddButton);
	DDX_Control(pDX, IDC_FILE_DELETE, m_fileRemoveButton);
	DDX_Control(pDX, IDC_SAVE_POS, m_savePosText);
	DDX_Control(pDX, IDC_FOLDER_CHANGE, m_folderSelectButton);
	DDX_Control(pDX, IDC_FOLDER_OPEN, m_folderOpenButton);
	DDX_Control(pDX, IDC_AFTER_CONVERT, m_afterConvertText);
	DDX_Control(pDX, IDC_CONVERT, m_convertButton);
	DDX_Control(pDX, IDC_ADOBE_CHECK, m_adobeCheckButton);
	DDX_Control(pDX, IDC_CHECK_OPEN_FOLDER, m_convertFolderButton);
	DDX_Control(pDX, IDC_AREA_DIVIDER, m_areaDivider);

	SetInterfaceButton();
	SetInterfacePos();
	SetInterfaceText();
}

BEGIN_MESSAGE_MAP(CDNGConverterDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FILE_DELETE, &CDNGConverterDlg::OnBnClickedDelFile)
	ON_BN_CLICKED(IDC_FILE_SELECT, &CDNGConverterDlg::OnBnClickedSelFile)
	ON_BN_CLICKED(IDC_FOLDER_CHANGE, &CDNGConverterDlg::OnBnClickedChangeFolder)
	ON_BN_CLICKED(IDC_FOLDER_OPEN, &CDNGConverterDlg::OnBnClickedOpenFolder)
	ON_BN_CLICKED(IDC_CONVERT, &CDNGConverterDlg::OnBnClickedConvert)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_ADOBE_CHECK, &CDNGConverterDlg::OnBnClickedAdobeCheck)
	ON_COMMAND(ID_M_CONVERT, &CDNGConverterDlg::OnMConvert)
	ON_COMMAND(ID_M_REMOVEFILE, &CDNGConverterDlg::OnMRemovefile)
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, &CDNGConverterDlg::OnNMRClickList)
	ON_NOTIFY(HDN_ITEMSTATEICONCLICK, 0, &CDNGConverterDlg::OnHdnItemStateIconClickList1)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, &CDNGConverterDlg::OnNMClickList1)
	ON_NOTIFY(LVN_HOTTRACK, IDC_LIST1, &CDNGConverterDlg::OnLvnHotTrackList1)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, &CDNGConverterDlg::OnDoubleClickList)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST1, &CDNGConverterDlg::OnColumnclickList)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CDNGConverterDlg 메시지 처리기

BOOL CDNGConverterDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 시스템 메뉴에 "정보..." 메뉴 항목을 추가합니다.

	// IDM_ABOUTBOX는 시스템 명령 범위에 있어야 합니다.
	//_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	
	//_CrtSetBreakAlloc(2699);
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	afxAmbientActCtx = FALSE;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 이 대화 상자의 아이콘을 설정합니다. 응용 프로그램의 주 창이 대화 상자가 아닐 경우에는
	//  프레임워크가 이 작업을 자동으로 수행합니다.
	SetIcon(m_hIcon, TRUE);			// 큰 아이콘을 설정합니다.
	SetIcon(m_hIcon, FALSE);		// 작은 아이콘을 설정합니다.

	// TODO: 여기에 추가 초기화 작업을 추가합니다.
	
	m_adobeCheckButton.LoadBitmaps(IDB_LIGHTROOM, IDB_LIGHTROOM_DOWN, IDB_LIGHTROOM, IDB_LIGHTROOM);

	//original
	//m_adobeCheckButton.LoadBitmaps(IDB_LIGHTROOM);

	m_bSortAscending = true;
	m_nSortColumn = 0;

	CString lang_FileList[4];
	

	lang_FileList[0].LoadStringW(IDS_FILE_NAME);
	lang_FileList[1].LoadStringW(IDS_PATH);
	lang_FileList[2].LoadStringW(IDS_SIZE);
	lang_FileList[3].LoadStringW(IDS_STATUS);

	m_fileList.ModifyStyle(LVS_OWNERDRAWFIXED,0,0);
	m_fileList.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_CHECKBOXES | LVS_EX_GRIDLINES | LVS_EX_SUBITEMIMAGES | LVS_EX_DOUBLEBUFFER); 

	m_fileList.InsertColumn(FILE_LIST_CHECKBOX,_T(""),LVCFMT_CENTER,25);
	m_fileList.InsertColumn(FILE_LIST_NAME,lang_FileList[0],LVCFMT_LEFT,223);
	m_fileList.InsertColumn(FILE_LIST_PATH,lang_FileList[1],LVCFMT_LEFT,270);
	m_fileList.InsertColumn(FILE_LIST_SIZE,lang_FileList[2],LVCFMT_LEFT,100);
	m_fileList.InsertColumn(FILE_LIST_STATE,lang_FileList[3],LVCFMT_LEFT,100);
	m_fileList.InsertColumn(FILE_LIST_DELETE,_T(""),LVCFMT_CENTER,46);
	

	imgList.Create(46,16,ILC_MASK,1,1);
	
	c1.LoadBitmap(IDB_CLOSE_NORMAL);
	c2.LoadBitmap(IDB_CLOSE_MOUSE_UP);
	c3.LoadBitmap(IDB_CLOSE_CLICKED);
	imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON_BLANK));
	imgList.Add(&c1, RGB(255,255,255));
	imgList.Add(&c2, RGB(255,255,255));
	imgList.Add(&c3, RGB(255,255,255));
	/*imgList.Create(16,16,ILC_MASK,1,1);
	imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON_BLANK));
	imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON_CLOSE_NORMAL));
	imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON_CLOSE_MOUSE_UP));
	imgList.Add(AfxGetApp()->LoadIcon(IDI_ICON_CLOSE_CLICKED));*/
	m_fileList.SetImageList(&imgList, LVSIL_SMALL);

	//===================
	header = ListView_GetHeader(m_fileList);
	DWORD dwHeaderStyle = ::GetWindowLong(header, GWL_STYLE);
	dwHeaderStyle |= HDS_CHECKBOXES;
	::SetWindowLong(header, GWL_STYLE, dwHeaderStyle);
	m_HeaderId = ::GetDlgCtrlID(header);
	m_HeaderState = false;
	HDITEM hdi = { 0 };
	hdi.mask = HDI_FORMAT;
	Header_GetItem(header, 0, &hdi);
	hdi.fmt |= HDF_CHECKBOX | HDF_FIXEDWIDTH;
	Header_SetItem(header, 0, &hdi);
	//===================
	//Header Checkbox 구현

	//===================

	DWORD dwType = REG_SZ;
	DWORD dwSize = 128;
	HKEY hKey;
	char szBuffer[128] = {0,};
	LONG lResult = RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\Samsung\\DNG Converter"), 0, KEY_QUERY_VALUE, &hKey);
	TCHAR *tszTemp = NULL;

	DWORD dwCnt = 0;
	CString defaultPath = NULL, userName;
	LPTSTR pStr = NULL;	
	WTSQuerySessionInformation( WTS_CURRENT_SERVER_HANDLE, WTS_CURRENT_SESSION, WTSUserName, &pStr, &dwCnt );
	userName = pStr;
	WTSFreeMemory(pStr);

	defaultPath.Format(_T("C:\\Users\\%s\\Desktop\\Samsung DNG Converter\\"),userName);

	if(lResult != ERROR_SUCCESS)
		saveFilePath = defaultPath;
	else
		if(RegQueryValueEx(hKey , _T("SavePath") , 0 , &dwType , (LPBYTE)szBuffer , &dwSize) != ERROR_SUCCESS)
		{
			saveFilePath = defaultPath;	
		}
		else
		{
			saveFilePath.Format(_T("%s"), szBuffer);
			int rf = saveFilePath.ReverseFind('\\');
			int sf = saveFilePath.Find('\\');

			if(rf == sf+1)
				saveFilePath.Delete(sf);
		}
			//saveFilePath = (CString)szBuffer;



	//saveFilePath = _T("D:\\");
	m_savePath.SetWindowText(saveFilePath);
	m_savePath.SetReadOnly();
	UpdateData(TRUE);
	//===================
	//save path 초기화
	
	//=============================]
	m_convertButton.EnableWindow(FALSE);
	m_fileRemoveButton.EnableWindow(FALSE);
	//m_fileList.CreateColumns();
	//m_fileList.InsertSomeItems();	

	SetTimer(1, 500, NULL);
	return TRUE;  // 포커스를 컨트롤에 설정하지 않으면 TRUE를 반환합니다.
}

void CDNGConverterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 대화 상자에 최소화 단추를 추가할 경우 아이콘을 그리려면
//  아래 코드가 필요합니다. 문서/뷰 모델을 사용하는 MFC 응용 프로그램의 경우에는
//  프레임워크에서 이 작업을 자동으로 수행합니다.

void CDNGConverterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 그리기를 위한 디바이스 컨텍스트입니다.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 클라이언트 사각형에서 아이콘을 가운데에 맞춥니다.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 아이콘을 그립니다.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// 사용자가 최소화된 창을 끄는 동안에 커서가 표시되도록 시스템에서
//  이 함수를 호출합니다.
HCURSOR CDNGConverterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//checkbox + 파일 삭제 버튼 눌렀을 시에 삭제 작업.
void CDNGConverterDlg::OnBnClickedDelFile()
{

	for(int i = m_fileList.GetItemCount()-1; i >= 0; i--)
	{
		BOOL checked = m_fileList.GetCheck(i);
		if(checked) m_fileList.DeleteItem(i);
		//if(checked) m_fileList.DeleteProgressItem(i);
	}
	
	CString temp, fileListText;
	
	temp.LoadStringW(IDS_FILE_LIST);
	fileListText.Format(_T("%s (%d)"),temp,m_fileList.GetItemCount());
	m_fileListText.SetWindowTextW(fileListText);

	ControlHeaderCheckbox(false);
	if(m_fileList.GetItemCount() == 0)
	{
		m_fileRemoveButton.EnableWindow(FALSE);
		m_convertButton.EnableWindow(FALSE);
	}
}


void CDNGConverterDlg::FindFilesInFolder(CString filePath)
{
	CFileFind find; 
	CString path;
	CString fname;
	CString pname;
	path = filePath;
	path += "\\*.*";

	BOOL bWorking = find.FindFile((LPCTSTR)path);

	while(bWorking)
	{
		bWorking = find.FindNextFile();
		if(find.IsArchived())
		{
			//check jpg temporarily.. 
			DNG dng;
			dng.setFileName(find.GetFileName());
			dng.setFilePath(find.GetFilePath());
			dng.setSize(find.GetLength());
			mDngFileList.push_back(dng);
		}
	}
}

CString CDNGConverterDlg::CropFileName(CString filePath)
{
	CString temp;
	temp = filePath;
	int i = temp.ReverseFind('\\');
	return temp.Left(i+1); 
}

//파일 선택
void CDNGConverterDlg::OnBnClickedSelFile()
{
	TCHAR current_path[MAX_PATH];
	TCHAR file_list[4096] = {0};
	GetCurrentDirectory(MAX_PATH,current_path);
	CFileDialog fileDialog(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT,
		_T("SRW Files|*.srw|All Files (*.*)|*.*|"));
	
	fileDialog.m_ofn.lpstrFile = file_list;
	fileDialog.m_ofn.nMaxFile = 4096;

	if(fileDialog.DoModal()==IDOK)
	{
		CFileFind find; 
		

		POSITION pos = fileDialog.GetStartPosition();
		int list_num = m_fileList.GetItemCount();
		while( pos!=NULL)
		{
			CString pathName = fileDialog.GetNextPathName(pos);
			CString fileName = pathName, extention = pathName;
			CString progress;
			BOOL bWorking = find.FindFile(pathName);
			BOOL checkOverlap = false;
			int nlx = fileName.ReverseFind('\\');
			int elx = extention.ReverseFind('.');
			progress.LoadString(IDS_STATE_WAITING);
			extention.Delete(0, elx+1);
			fileName.Delete(0, nlx+1);

			if(extention.CompareNoCase(L"srw"))
			{
				nsd.DoModal();
				continue;
			}


			for(int i = 0; i < m_fileList.GetItemCount(); i++)
			{
				CString tempFilePath;
				CString fileName = m_fileList.GetItemText(i, FILE_LIST_NAME);
				CString path = m_fileList.GetItemText(i, FILE_LIST_PATH);

				tempFilePath.Format(L"%s%s",path,fileName);
				
				if(!pathName.Compare(tempFilePath))
				{
					checkOverlap = true;
					break;
				}
			}

			if(checkOverlap)
				continue;

			bWorking = find.FindNextFile();
			m_fileList.InsertItem(list_num, _T(""));
			//m_fileList.SetItem(list_num, 0, LVIF_TEXT, L"asdf", 0, 0, 0, NULL );
			m_fileList.SetItem(list_num, FILE_LIST_NAME, LVIF_TEXT, fileName, 0, 0, 0, NULL ); 
			m_fileList.SetItem(list_num, FILE_LIST_PATH, LVIF_TEXT, CropFileName(pathName), 0, 0, 0, NULL ); 
			CString cSize;
			cSize.Format(_T("%.1fM"),(float)find.GetLength()/1024/1024);
			m_fileList.SetItem(list_num, FILE_LIST_SIZE, LVIF_TEXT, cSize, 0, 0, 0, NULL );
			m_fileList.SetItem(list_num, FILE_LIST_STATE, LVIF_TEXT, progress, 0, 0, 0, NULL );

			LVITEM lvItem;
			lvItem.iItem = list_num;
			lvItem.iSubItem = FILE_LIST_DELETE;
			lvItem.iImage = 1;
			lvItem.mask = LVIF_IMAGE;
			//lvItem.pszText = L"×";

			m_fileList.SetItem(&lvItem);
			m_fileList.SetCheck(list_num, 1);
			//m_fileList.SetItem
			//m_fileList.CreateProgress(list_num);
			list_num= m_fileList.GetItemCount();
		}
	}
	
	if(m_fileList.GetItemCount() != 0)
	{
		ControlHeaderCheckbox(true);
		m_convertButton.EnableWindow(TRUE);
		m_fileRemoveButton.EnableWindow(TRUE);
	}
	else
	{
		ControlHeaderCheckbox(false);
		m_convertButton.EnableWindow(FALSE);
		m_fileRemoveButton.EnableWindow(FALSE);
	}

	CString temp, fileListText;
	
	temp.LoadStringW(IDS_FILE_LIST);
	fileListText.Format(_T("%s (%d)"),temp,m_fileList.GetItemCount());
	m_fileListText.SetWindowTextW(fileListText);
	SetCurrentDirectory(current_path);
}


// 폴더 변경
void CDNGConverterDlg::OnBnClickedChangeFolder()
{
	ITEMIDLIST  *pidIBrowse = NULL;
	WCHAR	     pszPathName[MAX_PATH];

	BROWSEINFO  brInfo;
	memset(&brInfo,0,sizeof(brInfo));

	brInfo.hwndOwner = GetSafeHwnd();
	brInfo.pidlRoot  = NULL;
	brInfo.pszDisplayName   = (LPWSTR) pszPathName;
	brInfo.lpszTitle		= _T("Change directory");
	brInfo.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE ;

	pidIBrowse = ::SHBrowseForFolder(&brInfo);
	
	if(pidIBrowse!=NULL)
	{
		BOOL bSuccess = SHGetPathFromIDList(pidIBrowse, (LPWSTR) pszPathName);

		if(bSuccess)
		{
			saveFilePath = pszPathName;
			if(saveFilePath.GetLength()-1 == saveFilePath.ReverseFind('\\'))
				saveFilePath.Format(_T("%s"),saveFilePath);
			else
				saveFilePath.Format(_T("%s\\"),saveFilePath);
			m_savePath.SetWindowTextW(saveFilePath);
			UpdateData(TRUE);

			CRegKey RegKey;
			RegKey.Create(HKEY_CURRENT_USER , _T("SOFTWARE\\Samsung\\DNG Converter")); 
			RegKey.SetStringValue(_T("SavePath"), saveFilePath);
			RegKey.Close(); 

		}
	}

}

// 폴더 열기 Button 클릭 Method
void CDNGConverterDlg::OnBnClickedOpenFolder()
{
	if(saveFilePath.Compare(L""))
		ShellExecute(NULL, _T("open"), _T("explorer.exe"), saveFilePath, NULL, SW_SHOW); 
}

//================================================

void CDNGConverterDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);	
}

// Adobe Lightroom Button 클릭시 Adobe Lightroom check, 실행 해주는 Method
void CDNGConverterDlg::OnBnClickedAdobeCheck()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	DWORD dwType = REG_SZ;
	DWORD dwSize = 128;
	HKEY hKey;
	LONG lResult;
	char szBuffer[128] = {0,};

	lResult = RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("Adobe.AdobeLightroom"), 0, KEY_QUERY_VALUE, &hKey);
	//lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("SOFTWARE"), 0, KEY_ALL_ACCESS, &hKey);
	
	if(lResult != ERROR_SUCCESS)
	{
		
		lrd.DoModal();
	}
	else
	{
		if(RegQueryValueExA(hKey , "DefaultIcon" , 0 , &dwType , (LPBYTE)szBuffer , &dwSize) != ERROR_SUCCESS)
		{
			lrd.DoModal();
		}		
		else
		{
			ShellExecuteA(NULL, "open", szBuffer, NULL, NULL, SW_SHOW);
		}
	}

	if(hKey != NULL) RegCloseKey( hKey);
}

// cFileList 내의 우클릭, Menu 띄워주는 Method
void CDNGConverterDlg::OnNMRClickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_LIST_RIGHTCLICK_MENU));

	menuSelectItem = m_fileList.GetNextItem(-1,LVNI_SELECTED);
	
	

	if(menuSelectItem == -1)
		return;

	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);

	if(threadRun)
	{
		EnableMenuItem(*pPopup, 0, MF_BYPOSITION|MF_GRAYED); 
		EnableMenuItem(*pPopup, 1, MF_BYPOSITION|MF_GRAYED); 
	}

	POINT pt={0};
	GetCursorPos(&pt);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pt.x, pt.y, this);
	
	*pResult = 0;
	
}

// cFileList 내의 우클릭, 삭제 메뉴 실행 method
void CDNGConverterDlg::OnMRemovefile()
{
	if(menuSelectItem == -1 || menuSelectItem >= m_fileList.GetItemCount())
		MessageBox(_T("Error, OnMRemovefile()"));
	else
	{
		while(menuSelectItem != -1)
		{
			m_fileList.DeleteItem(menuSelectItem);
			menuSelectItem = m_fileList.GetNextItem(-1,LVNI_SELECTED);
		}
	}

	CString temp, fileListText;
	
	temp.LoadStringW(IDS_FILE_LIST);
	fileListText.Format(_T("%s (%d)"),temp,m_fileList.GetItemCount());
	m_fileListText.SetWindowTextW(fileListText);

	if(m_fileList.GetItemCount() == 0)
	{
		m_fileRemoveButton.EnableWindow(FALSE);
		m_convertButton.EnableWindow(FALSE);
	}
}

// Convert 클릭시 Method.
void CDNGConverterDlg::OnBnClickedConvert()
{
	BOOL notSupport = false;
	int i = 0, k = -1;
	int check = 0;
	
	
	//------------------- drive 용량 check

	while(i < m_fileList.GetItemCount())	// check된 파일 check 및 용량 계산할 drive 검색.
	{
		if(m_fileList.GetCheck(i)) 
		{
			if(k==-1)
				k=i; 
			check++;

			CFileFind dirFind;
			CString inputFileName = m_fileList.GetItemText(i, FILE_LIST_NAME);
			CString inputPath = m_fileList.GetItemText(i, FILE_LIST_PATH);
			CString inputFilePath;
			inputFilePath.Format(L"%s%s",inputPath,inputFileName);
			BOOL check = dirFind.FindFile(inputFilePath);// 파일 잘 있나 확인

			if(!check)
			{
				int connect = 1;

				while(connect)
				{
					
					ued.DoModal();

					if(ued.state == USB_CONNECT_CANCEL)
					{
						connect = 0;
						for(int i = m_fileList.GetItemCount()-1; i >= 0; i--)
							m_fileList.DeleteItem(i);
						return;
					}
					else
					{
						if(dirFind.FindFile(inputFilePath))
							connect = 0;
					}
				}
			}
		}
		i++;	
	}
	if(check == 0)	// check된 파일 check
		return;

	if(!CheckStorage(k,STORAGE_TEST, check)) // 용량 체크
	{
		
		mld.DoModal();
		return;
	}
	
	//m_convertButton.EnableWindow(TRUE);
	//m_convertButton.EnableWindow(FALSE);
	//m_convertButton.EnableWindow(FALSE);
	//m_fileAddButton.EnableWindow(FALSE);
	m_convertButton.SetState(FALSE);
	if(!threadRun)
	{
		tParam.cCtrl = &m_fileList; 
		tParam.outPath = &m_savePath;
		tParam.singleSelect = -1;
		tParam.startPoint = 0;
		cwt = ::AfxBeginThread(ConvertThreadFunc, &tParam);
		
	}

	
	
}

// cFileList 내의 우클릭, convert file 메뉴 실행 method
void CDNGConverterDlg::OnMConvert()
{
	int ret = 0;
	int firstSelectItem = m_fileList.GetNextItem(-1,LVNI_SELECTED);

	//------------ 파일 유무 체크
	CFileFind dirFind;
	CString inputFileName = m_fileList.GetItemText(firstSelectItem, FILE_LIST_NAME);
	CString inputPath = m_fileList.GetItemText(firstSelectItem, FILE_LIST_PATH);
	CString inputFilePath;
	inputFilePath.Format(L"%s%s",inputPath,inputFileName);
	BOOL check = dirFind.FindFile(inputFilePath);// 파일 잘 있나 확인

	if(!check)
	{
		int connect = 1;

		while(connect)
		{
			ued.DoModal();

			if(ued.state == USB_CONNECT_CANCEL)
			{
				connect = 0;
				m_fileList.DeleteItem(firstSelectItem);
				return;
			}
			else
			{
				if(dirFind.FindFile(inputFilePath))
					connect = 0;
			}
		}
	}

	//------------- 용량 체크

	if(!CheckStorage(firstSelectItem,STORAGE_TEST,1))
	{
		mld.DoModal();
		return;
	}


	//------------- file 확장자 check
	CString fileName = m_fileList.GetItemText(firstSelectItem, FILE_LIST_NAME);
	int nlx = fileName.ReverseFind('.');
	fileName.Delete(0, nlx+1);	

	if(!threadRun)
	{
		tParam.cCtrl = &m_fileList; 
		tParam.outPath = &m_savePath;
		tParam.singleSelect = firstSelectItem;
		tParam.startPoint = 0;
		cwt = ::AfxBeginThread(ConvertThreadFunc, &tParam);
	}
}


int CDNGConverterDlg::ControlHeaderCheckbox(bool check)
{
	HDITEM hdi = { 0 };
	hdi.mask = HDI_FORMAT;
	Header_GetItem(header, 0, &hdi);
	if(check)
	{
		hdi.fmt |= 128;
	}
	else
	{
		hdi.fmt &= ~128;
	}
	Header_SetItem(header, 0, &hdi);

	return 1;
}

void CDNGConverterDlg::OnHdnItemStateIconClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	HDITEM hdi = { 0 };
	hdi.mask = HDI_FORMAT;
	int itemNum = m_fileList.GetItemCount();
	Header_GetItem(header, 0, &hdi);

	if((hdi.fmt & 128) == 128)
	{
		if(itemNum != 0)
		{
			m_convertButton.EnableWindow(FALSE);
			m_fileRemoveButton.EnableWindow(FALSE);
		}
		for(int i = itemNum-1; i >= 0; i--)
			 m_fileList.SetCheck(i,0);
	}
	else
	{
		if(itemNum != 0)
		{
			m_convertButton.EnableWindow(TRUE);
			m_fileRemoveButton.EnableWindow(TRUE);
		}
		for(int i = itemNum-1; i >= 0; i--)
			 m_fileList.SetCheck(i,1);
	}

	*pResult = 0;
}


void CDNGConverterDlg::OnLvnHotTrackList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	if(pNMLV->iItem != -1 && pNMLV->iSubItem == FILE_LIST_DELETE)
	{
		LVITEM lvItem;


		for(int i = 0; i < m_fileList.GetItemCount(); i++)
		{
			lvItem.iItem = i;
			lvItem.iSubItem = FILE_LIST_DELETE;
			lvItem.mask = LVIF_IMAGE;
			m_fileList.GetItem( &lvItem );
			if(i == pNMLV->iItem)
			{
				if( lvItem.iImage != 2 )
				{
					lvItem.iImage = 2;
					m_fileList.SetItem(&lvItem);
				}
			}
			else
			{
				if( lvItem.iImage == 2 )
				{
					lvItem.iImage = 1;
					m_fileList.SetItem(&lvItem);
				}
			}
		}
	}
	else
	{
		LVITEM lvItem;

		for(int i = 0; i < m_fileList.GetItemCount(); i++)
		{
			lvItem.iItem = i;
			lvItem.iSubItem = FILE_LIST_DELETE;
			lvItem.mask = LVIF_IMAGE;
			m_fileList.GetItem( &lvItem );
			if( lvItem.iImage == 2 )
			{
				lvItem.iImage = 1;
				m_fileList.SetItem(&lvItem);
			}
		}
	}

	*pResult = 0;
}

void CDNGConverterDlg::OnDoubleClickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	CheckBoxControlHeader();

	*pResult = 0;
}


// list 오른쪽 삭제 이미지 클릭
void CDNGConverterDlg::OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	if(pNMItemActivate->iItem != -1 && pNMItemActivate->iSubItem == FILE_LIST_DELETE && !threadRun)
	{
		m_fileList.DeleteItem(pNMItemActivate->iItem);
	}
	CheckBoxControlHeader();

	CString temp, fileListText;
	
	temp.LoadStringW(IDS_FILE_LIST);
	fileListText.Format(_T("%s (%d)"),temp,m_fileList.GetItemCount());
	m_fileListText.SetWindowTextW(fileListText);

	if(m_fileList.GetItemCount() == 0)
	{
		m_fileRemoveButton.EnableWindow(FALSE);
		m_convertButton.EnableWindow(FALSE);
	}


	*pResult = 0;
}

// CheckBox Check 수에 따른 Header Checkbox Control
void CDNGConverterDlg::CheckBoxControlHeader()
{
	// checkbox click
	int nItemCnt = m_fileList.GetItemCount();
	int checkedItem = 0;

    LVHITTESTINFO ht = {0};
    CPoint pt;
    GetCursorPos(&pt);
   
    m_fileList.ScreenToClient(&pt);
    ht.pt = pt;
    ht.flags = LVHT_ONITEMICON;
   
    int nCursorItem = m_fileList.SubItemHitTest(&ht);

    if(nCursorItem == -1)
		return;                   
 
    if(ht.flags == LVHT_ONITEMSTATEICON)
    {
       for(int nCnt=0; nCnt<nItemCnt; nCnt++)
		   if(nCnt == nCursorItem)
		   {
			   if(!m_fileList.GetCheck(nCnt))
				   ++checkedItem;
		   }
		   else
		   {
			   if(m_fileList.GetCheck(nCnt))
				   ++checkedItem;
		   }

	   if(checkedItem != 0)
	   {
			m_fileRemoveButton.EnableWindow(TRUE);
			m_convertButton.EnableWindow(TRUE);
			if(checkedItem != nItemCnt)
				ControlHeaderCheckbox(false);
			else
				ControlHeaderCheckbox(true);
	   }
	   else
	   {
			m_fileRemoveButton.EnableWindow(FALSE);
			m_convertButton.EnableWindow(FALSE);
			ControlHeaderCheckbox(false);
	   }
    }
	//checkbox click
}

// 용량 check
BOOL CDNGConverterDlg::CheckStorage(int tempPathNum, int fileSize, int checkFiles)
{
	ULARGE_INTEGER avail, total, free;
	int m_free;
	CString driveName = m_fileList.GetItemText(tempPathNum, FILE_LIST_PATH);
	int cut = driveName.Find('\\');
	driveName.Delete(cut+1,driveName.GetLength());
	avail.QuadPart = 0L; total.QuadPart = 0L; free.QuadPart = 0L;
	GetDiskFreeSpaceEx(driveName,&avail,&total,&free);
	m_free = (int)(free.QuadPart>>20);

	if(m_free < fileSize*checkFiles)
	{
		return false;
	}

	return true;
}


// usb 해제 관련
LRESULT CDNGConverterDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: 여기에 특수화된 코드를 추가 및/또는 기본 클래스를 호출합니다.
	
	if(message == WM_DEVICECHANGE)
	{
        CString str;
		PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR) lParam;
		PDEV_BROADCAST_VOLUME lpdbv = (PDEV_BROADCAST_VOLUME)lpdb;
        UINT event = (UINT)wParam;
		if(event == DBT_DEVICEREMOVECOMPLETE && threadRun)
	   {
            // USB에서 어떤 장치가 제거됐는데 in thread 인 경우.
			int find;
			CString tempStr;

			str.Format(_T("%c:\\"), FirstDriveFromMask(lpdbv->dbcv_unitmask));

			m_savePath.GetWindowTextW(tempStr);					// output drive check
			find = tempStr.Find(str);			

			if(find == USB_DISCONNECT_INCORRECT)				// input drive check
				for(int i = 0; i < m_fileList.GetItemCount(); i++)	
				{
					tempStr = m_fileList.GetItemText(i, 2);
					find = tempStr.Find(str);
					if(find != -1)
						break;
				}
			if(find != USB_DISCONNECT_INCORRECT)
			{
				threadRun = false;

				int connect = 1;

				while(connect)
				{
					ued.DoModal();

					if(ued.state == USB_CONNECT_CANCEL)
					{
						connect = 0;
						for(int i = m_fileList.GetItemCount()-1; i >= 0; i--)
							m_fileList.DeleteItem(i);
						m_fileAddButton.EnableWindow(true);
						
						CString temp, fileListText;
	
						temp.LoadStringW(IDS_FILE_LIST);
						fileListText.Format(_T("%s (%d)"),temp,m_fileList.GetItemCount());
						m_fileListText.SetWindowTextW(fileListText);
					}
					else
					{
						CFileFind dirFind;
						CString inputFileName = m_fileList.GetItemText(n_ThreadWork, FILE_LIST_NAME);
						CString inputPath = m_fileList.GetItemText(n_ThreadWork, FILE_LIST_PATH);
						CString inputFilePath;
						inputFilePath.Format(L"%s%s",inputPath,inputFileName);


						BOOL check = dirFind.FindFile(inputFilePath);
						if(check)
						{
							::WaitForSingleObject(cwt, INFINITE);

							tParam.cCtrl = &m_fileList; 
							tParam.outPath = &m_savePath;
							tParam.singleSelect = n_ThreadSingleSelected;
							tParam.startPoint = n_ThreadWork;

							cwt = ::AfxBeginThread(ConvertThreadFunc, &tParam);
							connect = 0;
						}
					}
				}
			}
		}
    }
	return CDialogEx::DefWindowProc(message, wParam, lParam);
}

// Header 클릭시 sort
void CDNGConverterDlg::OnColumnclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	 NM_LISTVIEW* pNMListView = (NM_LISTVIEW*) pNMHDR;
     int iColumn = pNMListView->iSubItem;
     if (iColumn == m_nSortColumn) {
         m_bSortAscending = !m_bSortAscending;
     }
     else { 
         m_bSortAscending = TRUE;
     }
     m_nSortColumn = iColumn; 
 
     int nItem = m_fileList.GetItemCount();
     CString** arStr = new CString*[nItem];
     for (int i=0; i<nItem; i++) {
         arStr[i] = new CString(m_fileList.GetItemText(i, iColumn));
         m_fileList.SetItemData(i, (LPARAM)arStr[i]);
     }

     m_fileList.SortItems(CompareFunc, (LPARAM)m_bSortAscending);
 
     for (int i=0; i<nItem; i++)
         delete arStr[i];
     delete []arStr;

	*pResult = 0;
}

BOOL CDNGConverterDlg::DestroyWindow()
{
	// TODO: 여기에 특수화된 코드를 추가 및/또는 기본 클래스를 호출합니다.

	return CDialogEx::DestroyWindow();
}

void CDNGConverterDlg::SetInterfaceText()
{
	CString temp, fileListText, space;
	
	
	CDC *pDC = GetDC();
	CSize stringSize;
	int titleSize, setSize;
	
	fileListText.LoadStringW(IDS_TITLE_NX);
	stringSize = pDC->GetTextExtent(fileListText);
	titleSize = stringSize.cx;
	setSize = 400 - titleSize/2;
	stringSize = pDC->GetTextExtent(_T(" "));
	setSize /= stringSize.cx;
	
	/*for(int i =0; i < setSize; ++i)
		space += _T(" ");
	temp.Format(_T("%s%s"), space,fileListText);
	SetWindowTextW(temp);*/
	// title 가운데 정렬
	SetWindowTextW(fileListText);



	temp.LoadStringW(IDS_FILE_LIST);
	fileListText.Format(_T("%s (%d)"),temp,m_fileList.GetItemCount());
	m_fileListText.SetWindowTextW(fileListText);
	temp.LoadStringW(IDS_OUTPUT_FOLDER);
	m_savePosText.SetWindowTextW(temp);
	temp.LoadStringW(IDS_OPEN_AFTER_CONVERT);
	m_afterConvertText.SetWindowTextW(temp);
	temp.LoadStringW(IDS_ADD_FILE);
	m_fileAddButton.SetWindowTextW(temp);
	temp.LoadStringW(IDS_REMOVE_FILE);
	m_fileRemoveButton.SetWindowTextW(temp);
	temp.LoadStringW(IDS_SELECT_FOLDER);
	m_folderSelectButton.SetWindowTextW(temp);
	temp.LoadStringW(IDS_OPEN_FOLDER);
	m_folderOpenButton.SetWindowTextW(temp);
	temp.LoadStringW(IDS_CONVERT);
	m_convertButton.SetWindowTextW(temp);
	//temp.Format(_T(" "));
	//temp.LoadStringW(IDS_ADOBE_LIGHTROOM);
	//m_adobeCheckButton.SetWindowTextW(temp);
}
void CDNGConverterDlg::SetInterfacePos()
{
	CFont size14, bold, size8;
	LOGFONT lf14, lfB, lf8;
	CRect nRect;

	::ZeroMemory(&lf8, sizeof(lf8));
	::ZeroMemory(&lf14, sizeof(lf14));
	::ZeroMemory(&lfB, sizeof(lfB));

	lf14.lfHeight = 14;
	lf8.lfHeight = 12;
	lfB.lfHeight = 14;
	lfB.lfWeight = FW_BOLD;

	size14.CreateFontIndirectW(&lf14);
	bold.CreateFontIndirectW(&lfB);
	size8.CreateFontIndirectW(&lf8);

	GetWindowRect(&nRect);

	SetMenu(NULL);
	MoveWindow(nRect.left, nRect.top, 800, 500);
	//CenterWindow();

	m_fileListText.MoveWindow(29, 14, 500, 14); // -0 -35
	m_fileListText.SetFont(&bold);
	m_afterConvertText.MoveWindow(50, 405, 400, 14);
	m_afterConvertText.SetFont(&size14);
	m_savePosText.MoveWindow(28, 353, 150, 14);
	m_savePosText.SetFont(&bold);
	
	m_fileList.MoveWindow(16, 44, 768, 266);
	m_areaDivider.MoveWindow(18, 322, 637, 117);
	m_savePath.MoveWindow(28, 375, 508, 20);

	m_fileAddButton.MoveWindow(612, 7, 84, 26);
	m_fileRemoveButton.MoveWindow(702, 7, 84, 26);
	m_convertFolderButton.MoveWindow(28, 405, 12, 12);
	m_folderSelectButton.MoveWindow(546, 375, 98, 20);
	m_folderOpenButton.MoveWindow(546, 405, 98, 20);
	m_convertButton.MoveWindow(674, 328, 110, 73);
	m_adobeCheckButton.MoveWindow(674, 412, 110, 33);
	//m_adobeCheckButton.MoveWindow(674, 412, 120, 37);

	if(language == LANG_FRENCH)
	{
		m_savePath.MoveWindow(28, 375, 495, 20);
		m_fileAddButton.MoveWindow(580, 7, 101, 26);
		m_fileRemoveButton.MoveWindow(684, 7, 101, 26);
		m_folderSelectButton.MoveWindow(531, 375, 115, 20);
		m_folderOpenButton.MoveWindow(531, 405, 115, 20);
		m_fileAddButton.SetFont(&size8);
		m_fileRemoveButton.SetFont(&size8);
		m_folderSelectButton.SetFont(&size8);
	}

	size8.Detach();
	size14.Detach();
	bold.Detach();
}

void CDNGConverterDlg::SetInterfaceButton()
{

}

UINT ConvertThreadFunc(LPVOID pParam)
{
	CDNGConverterDlg::t_Param *threadParam = (CDNGConverterDlg::t_Param*)pParam;
	CDNGConverterDlg* rootDlg = (CDNGConverterDlg*)AfxGetApp()->GetMainWnd();
	CListCtrl* m_fileList = threadParam->cCtrl;
	CEdit* outEdit = threadParam->outPath;
	int singleSelected = threadParam->singleSelect;

	rootDlg->m_convertButton.EnableWindow(FALSE);
	rootDlg->m_fileAddButton.EnableWindow(FALSE);
	rootDlg->m_fileRemoveButton.EnableWindow(FALSE);
	m_fileList->EnableWindow(FALSE);
	rootDlg->threadRun = true;

	int ret = 0,i = 0, successProcess = 0, totalProcess = 0;
	CString outputPath;
	outEdit->GetWindowTextW(outputPath);

	CFileFind file;
	BOOL bResult = file.FindFile(outputPath);
 
    if(!bResult)
    {
        bResult = CreateDirectory(outputPath, NULL);
    }
	
	rootDlg->n_ThreadSingleSelected = singleSelected;

	while( i < m_fileList->GetItemCount() )
	{
		if(m_fileList->GetCheck(i)) totalProcess++;
		i++;
	}

	i = threadParam->startPoint;
	do
	{
		
		if(m_fileList->GetCheck(i) || singleSelected != -1)
		{
			if(singleSelected != -1)
			{
				i = singleSelected;
				totalProcess = 1;
			}
			rootDlg->n_ThreadWork = i;

			CString inputFileName = m_fileList->GetItemText(i, FILE_LIST_NAME);
			CString inputPath = m_fileList->GetItemText(i, FILE_LIST_PATH);
			CString inputFilePath;
			inputFilePath.Format(L"%s%s",inputPath,inputFileName);				// intput filename 형성

			CString outputFilePath;
			CString outputFileName = inputFileName;
			int nlx = outputFileName.ReverseFind('.');
			outputFileName.Delete(nlx, outputFileName.GetLength());
			outputFilePath.Format(_T("%s%s%s"),outputPath,outputFileName,_T(".dng"));	// output filename 형성

			// check output
			WIN32_FIND_DATAW findData;
			HANDLE file = FindFirstFile(outputFilePath,&findData);

			if(file != INVALID_HANDLE_VALUE)
			{
				
				rootDlg->snd.sameName = outputFilePath;
				if(rootDlg->snd.state == STATE_UNABLE)
				{
					rootDlg->threadRun = false;
					rootDlg->snd.DoModal();
				}

				switch(rootDlg->snd.state)
				{
				case CANCEL_BUTTON_CLICKED:
					rootDlg->m_fileAddButton.EnableWindow(TRUE);
					rootDlg->m_convertButton.EnableWindow(TRUE);
					rootDlg->m_fileRemoveButton.EnableWindow(TRUE);
					m_fileList->EnableWindow(TRUE);
					rootDlg->snd.state = STATE_UNABLE;
					return -1;
					break;
				case OVERLAP_BUTTON_CLICKED:
					rootDlg->threadRun = true;
					break;
				case COPY_BUTTON_CLICKED:
					CString copyFilePath;
					copyFilePath.Format(_T("%s%s%s"),outputPath,outputFileName,_T("(2).dng"));
					CopyFile(outputFilePath,copyFilePath,false);
					rootDlg->threadRun = true;
					break;
				}

				if(rootDlg->snd.state == JUMP_BUTTON_CLICKED)
				{
					i++;
					if(!rootDlg->snd.stateFixed)
						rootDlg->snd.state = STATE_UNABLE;
					rootDlg->threadRun = true;
					continue;	
				}
			}
			if(!rootDlg->snd.stateFixed)
				rootDlg->snd.state = STATE_UNABLE;
			
			
			int inputLen = ::WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)inputFilePath, -1, NULL, 0, NULL, NULL); 
			char* iUtf8 = (char*)malloc(inputLen*sizeof(char));
			::WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)inputFilePath, -1, iUtf8, inputLen, NULL, NULL);

			int outputLen = ::WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)outputFilePath, -1, NULL, 0, NULL, NULL); 
			char* oUtf8 = (char*)malloc(outputLen*sizeof(char));
			::WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)outputFilePath, -1, oUtf8, outputLen, NULL, NULL);
			
			CString resultString;
			resultString.LoadStringW(IDS_STATE_PROCESSING);
			m_fileList->SetItem(i, FILE_LIST_STATE, LVIF_TEXT, resultString, 0, 0, 0, NULL );

/* 
PROCESSCOMPLETE     =  0,
PROCESSFAILED       = -1,
PROCESSCANCELED     = -2,
FILENOTSUPPORTED    = -3,
DNGSDKINTERNALERROR = -4
*/

			//if(inputLen == -100)
			ret = dngProcess(iUtf8, oUtf8 );
			//else
			//	ret = -1			
			free(iUtf8);
			free(oUtf8);
			

			if(ret == -3 && rootDlg->threadRun) // ----- file 확장자 check
			{
				
				rootDlg->threadRun = false;
				rootDlg->nsd.DoModal();
				rootDlg->threadRun = true;
				resultString.LoadStringW(IDS_STATE_WAITING);
				m_fileList->SetItem(i, FILE_LIST_STATE, LVIF_TEXT, resultString, 0, 0, 0, NULL );
			}
			else if(ret == 0 && rootDlg->threadRun)
			{
				resultString.LoadStringW(IDS_STATE_CONVERTED);
				m_fileList->SetItem(i, FILE_LIST_STATE, LVIF_TEXT, resultString, 0, 0, 0, NULL );
				successProcess++;
			}
			else if(rootDlg->threadRun)
			{
				
				inputFilePath.GetLength();
				TRACE("inputFileLength = %d ", inputFilePath.GetLength());
				if(inputFilePath.GetLength() > 51)
				{
					CString temp1;
					CString temp2;
					temp1 = inputFilePath.Left(51);
					temp2 = inputFilePath.Mid(51, inputFilePath.GetLength() - 51);
					if(temp2.GetLength() > 45)
					{
						temp2 = temp2.Left(45);
						temp2 += ".....";
					}					
					temp1 += "\r\n";
					temp1 += temp2;					
					rootDlg->ced.errorPath = temp1;
				}
				else
				{
					rootDlg->ced.errorPath = inputFilePath;
				}

				if(!rootDlg->ced.stateFixed)
				{
					rootDlg->threadRun = false;
					rootDlg->ced.DoModal();
				}
				resultString.LoadStringW(IDS_STATE_WAITING);
				m_fileList->SetItem(i, FILE_LIST_STATE, LVIF_TEXT, resultString, 0, 0, 0, NULL );

				if(!rootDlg->ced.jumpState)
				{
					rootDlg->m_fileAddButton.EnableWindow(TRUE);
					rootDlg->m_convertButton.EnableWindow(TRUE);
					rootDlg->m_fileRemoveButton.EnableWindow(TRUE);
					m_fileList->EnableWindow(TRUE);
					rootDlg->threadRun = false;
					return -1;
				}
				else
					rootDlg->threadRun = true;
			}
		}

		
		i++;
	}
	while(i < m_fileList->GetItemCount() && singleSelected == -1 && rootDlg->threadRun);

	rootDlg->snd.state = STATE_UNABLE;
	
	if(rootDlg->m_convertFolderButton.GetCheck())
	{
		ShellExecute(NULL, _T("open"), _T("explorer.exe"), outputPath, NULL, SW_SHOW); 
	}

	if(rootDlg->threadRun)
	{
		rootDlg->ccd.success = successProcess;
		rootDlg->ccd.total = totalProcess;
		rootDlg->ccd.openPath = outputPath;
		rootDlg->threadRun = false;
		rootDlg->ccd.DoModal();
	}

	rootDlg->threadRun = false;
	rootDlg->m_fileAddButton.EnableWindow(TRUE);
	rootDlg->m_convertButton.EnableWindow(TRUE);
	rootDlg->m_fileRemoveButton.EnableWindow(TRUE);
	m_fileList->EnableWindow(TRUE);
	return 0;
}

char FirstDriveFromMask( ULONG unitmask )
 {
  char i;

  for (i = 0; i < 26; ++i)
   {
    if (unitmask & 0x1)
      break;
    unitmask = unitmask >> 1;
   }

  return( i + 'A' );
}

static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParam)
{
    CString* pStr1 = (CString*)lParam1; // ItemData을 문자열로 형 변환
    CString* pStr2 = (CString*)lParam2;
    BOOL bSortAscending  = (BOOL)lParam; // 정렬 방식
 
	
	int result = pStr1->Compare(*pStr2); // strcmp 로 비교해서
    if (bSortAscending == TRUE) // 오름 차순이면 그냥 리턴
        return result;
    else // 아니면 반대로 리턴
        return -result;
    return 0;
}


void CDNGConverterDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: 여기에 메시지 처리기 코드를 추가 및/또는 기본값을 호출합니다.

	if( nIDEvent == 1 )
	{
		CWnd* pWnd = NULL;		
		pWnd = CWnd::FindWindow(NULL, _T("Samsung DNG Converter Ver 2.0.0"));

		if(pWnd)
		{	
			pWnd->SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
			
			KillTimer(1);		
		}
	}
	CDialogEx::OnTimer(nIDEvent);
}
