/***************************************************************************************************
                            
							  Lossless Raw Compressor

	File description
		Name:		define.h

    Udpate Date:	2013.10.31

	Camera Platform Lab. 
	Digital Media R&D Center 
	Samsung Electronics Co., Ltd.

	Contact: wh0225.joo@samsung.com

***************************************************************************************************/


#ifndef __DEFINE_H_
#define __DEFINE_H_

#ifndef SV_DPI_COMPILE
#include <windows.h>
#include "direct.h"
#else
//#include <inttypes.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define __DEBUG_
#ifdef __DEBUG_
#define	DEBUG_PRINT					printf
#else
#define	DEBUG_PRINT					
#endif

#ifndef TRUE
#define TRUE						1
#endif

#ifndef	FALSE
#define FALSE						0
#endif

#define GBRG						1

#define ALGORITHM					0

#define DATA_NOT_READY				0xffffffff

#define DEFAULT_PRED				0
#define REF_PREDICTION				1
#define GB_PREDICTION				2
#define NL_PREDICTION				3
#define UV_PREDICTION				4
#define JPEG_LS_PREDICTION			5
#define BLOCK_PREDICTION			6
#define YUVDYNAMIC_PREDICTION		7

#define BLOCK_SIZE					8
#define SUB_BLOCK_SIZE				4
#define SUB_BLOCK_NUM				(BLOCK_SIZE/SUB_BLOCK_SIZE)
#define SUB_BLOCK_0					0
#define SUB_BLOCK_1					1

#define IMG(ep, var, x, y, color)	*(((ep)->var[color]) + (x) + (y) * (ep)->nWidth[color])
#define	ABS(a)						(((a)>0) ? (a) : -(a))
#define MAX(a, b)					(((a)>(b)) ? (a) : (b))
#define MIN(a, b)					(((a)<(b)) ? (a) : (b))
#define CLIP(x, a, b)				(((x)<(a)) ? (a) : ((x)>(b)) ? (b) : (x))
#define CLIP_X(x, a, b)				(x) = (((x)<(a)) ? (a) : ((x)>(b)) ? (b) : (x))
#define I_POL(a, b)					((a[b]+a[b+1]+1)>>1)
#define u16(a)						((a)<0 ? ((unsigned short)(a)) : (a))
//#define u16(a)					((a)<0 ? (0x1000|((a)&0x7fff)) : ((a)&0x7fff))
#define u17(a)						((a)<0 ? (0x10000|((a)&0xffff)) : ((a)&0xffff))

#define D5_ELIMINATE_MMT
#define LRC_LOSSY_SUPPORT


//#define MV_DELAY					0	// encoder: TWO_CYCLE_DELAY
#define MV_DELAY					1	// encoder: ONE_CYCLE_DELAY
#define DYNAMIC_DELAY				0

#define OPTIMIZE_SKIP				0x1
#define OPTIMIZE_MV					0x2
#define OPTIMIZE_QP					0x4

#define TagNum  314// ZerothIFD 14 Makernote 95 Exif 64 	GPS 32  First 30	PrimaryRaw 15 PrimaryJPEG 29		ScreennailIFD 29 MPExtension 6// MetaData.txt  ִ  ݵ ġؾ .

typedef __int64				int64D5;
typedef unsigned __int64	uint64D5;
typedef int					int32D5;
typedef	short				int16D5;
typedef char					int8D5;
typedef unsigned int		uint32D5;
typedef unsigned short	uint16D5;
typedef unsigned char		uint8D5;

typedef uint16D5				pixel;
typedef int32D5				residue;

#define MAX_FILENUM					10

#define SUCCESS							0
#define ERROR_SYNTAX_MV				1
#define ERROR_SYNTAX_DR				2


typedef struct IOParam
{
	FILE *fp_rec;
	FILE *fp_srw;
	int8D5 *filename_rec;
	int8D5 *filename_srw;

} IOParam;

typedef struct DecoderParam
{
	uint8D5 *srw_stream;	//SRW stream data
	int Raw_stream_offset, Raw_stream_size;

	pixel	*pRec[3];				//  

	// bitstream  ó
	uint32D5	*bitstream, *_bitstream;	// Ʈ Ʈ 
	uint64D5	nBitBuff;
	uint32D5	nBitPos;
	uint32D5	nReservedBits[8];
	uint32D5	*nLineStartPos;				// line byte offset
	uint32D5	*nTileOffset;				// ο tile ۵Ǵ ġ
	uint32D5	*nTileBitPos;
	uint64D5	*nTileBitBuff;

	int32D5	nPredAlgorithm;
	int32D5	nBayerFilterArray;

	int32D5	nNLCVersion;
	int32D5	nNumBlkInRCUnit;
	int32D5	nTileWidth;
	int32D5	nOverlapWidth;
	int32D5	nTileNum;
	int32D5	nCompressionRatio;
	int32D5	bTileModeDec;
	int32D5	bTileModeEnc;
	int32D5	nInc;
	int32D5	nBnd_init_val;
	int32D5	bAlwaysGFirst;

	int32D5	nWidth[3], nHeight[3];		// R, G, B ũ
	int32D5	nOriWidth, nOriHeight;
	int32D5	nBitDepth;
	int32D5	nBlockSize[3];
	int32D5	nImgFormat;					//  
	int32D5	nErrorBoundSum;
	int32D5	nReadTotal;

	int32D5   nOptCode;
	int32D5	bQPIncluded;			// 1:QP Included, 0:QP,flag not included, when lossless mode

	// Prediction algorithm
	int32D5	(*InitInitSeq    )(DecoderParam *ep, int32D5 nSeqNum);
	int32D5	(*InitInitFrame  )(DecoderParam *ep, int32D5 nFrameNum);
	int32D5	(*CurrLineProcess)(DecoderParam *ep, int32D5 nLineNum);

	IOParam	ip;							// file io
} DecoderParam;

typedef struct MakerNoteParam
{
	int EntryNumber;
	//0001
	uint8D5 MakerNoteVersion[4];
	//0002
	uint32D5 SamsungDeviceID;
	//0003
	uint32D5 SamsungModelID;
	//0004
	char SamsungContentsID[10];
	//000A
	uint32D5 ContinuousShotMode[2];
	//000B
	uint16D5 BestPhotoMode;
	//000E
	uint32D5 SoundMultiPicture[2];
	//0020
	uint16D5 ColorInfoDCM[2];
	//0021
	uint16D5 PictureWizard[5];
	//0022
	uint32D5 Capture_Mode;
	//0023
	uint8D5 *ModelSerialNumber;
	//0025
	uint32D5 ImageCount;
	//002A
	uint8D5 SNSDirectShare[4];
	//002F
	uint8D5 *GPSInfo01;
	//0030
	uint8D5 GPSInfo_01[49];
	//0031
	uint8D5 GPSInfo02[23];
	//0032
	uint8D5 *GPSInfo03;
	//0033
	uint8D5 *GPSInfo04;
	//0034
	uint8D5 *GPSInfo05;
	//0035
	uint32D5 PreviewImageInfo;
	//003A
	uint16D5 SmartLensInfo[2];
	//003B
	uint16D5 PhotoStyleSelecInfo[2];
	//003C
	uint16D5 SmartRange;
	//003D
	uint16D5 SmartCropInfo[5];
	//003E
	uint32D5 DualCapture;
	//003F
	uint16D5 SGIFInfo[2];
	//0040
	uint32D5 FavoriteTagging;
	//0043
	int ImageTemperature[2];
	//0045
	uint32D5 RAWCompressionMode;
	//004A
	uint32D5 ImageVerification[7];
	//004B
	uint32D5 RewindInfo[2];
	//0050
	uint32D5 Color_Space;
	//0054
	uint16D5 WeatherInfo[2];
	//005A
	uint8D5 *PictureControlUtility;		// not implemented
	//0060
	uint8D5 *AE;
	//0080
	uint8D5 *AF;
	//00A0
	uint8D5  *AWB01;
	//00A1
	uint8D5 *AWB02;
	//00C0
	uint8D5 *IPC;
	//00C7
	uint8D5 *SmartFunctionInfo;
	//00E0
	uint16D5 SceneResult;
	//00E1
	uint16D5 SADebugInfo01[8];
	//00E2
	uint16D5 *SADebugInfo02;
	//0100
	uint16D5 FaceDetection;
	//0101
	uint16D5 FaceFeat01[6];
	//0102
	uint16D5 *FaceFeat02;
	//0120
	uint32D5 FaceRecognition;
	//0123
	uint8D5 *FaceNameInfo;
	//0140
	uint8D5 *LensInfo;
	//A000
	uint32D5 MakernoteVersion;
	//A001
	char BodyFirmwareVersion[30];
	//A002
	char BodySerialNumber[30];
	//A003
	uint16D5 LensID;
	//A004
	char LensFirmwareVersion[30];
	//A005
	char LensSerialNumber[30];
	//A010
	uint32D5 ImageSize[8];
	//A011
	uint16D5 ColorSpace;
	//A012
	uint16D5 CaptureMode;
	//A013
	uint32D5 ExpComp[3]; //[0]: numerator, [1]: denominator, [2]: numerator/denominator
	//A014
	int32D5 ISOGain;
	//A018
	uint32D5 ShutterSpeed[3]; //[0]: numerator, [1]: denominator, [2]: numerator/denominator
	//A019
	uint32D5 FNumber[3]; //[0]: numerator, [1]: denominator, [2]: numerator/denominator
	//A01A
	uint32D5 FocalLength35;
	//A01B
	uint32D5 Image_Count;
	//A01C
	uint16D5 LDCLens, LDCMenu;
	//A020
	uint32D5 EncryptionKey[11];
	//A021
	uint32D5 WBGain_CameraSetting[4];
	//A022
	uint32D5 WBGain_AWB[4];
	//A023
	uint32D5 WBGain_ALight[4];
	//A024
	uint32D5 WBGain_D65Light[4];
	//A025
	uint32D5 PostAEGain;
	//A028
	int32D5 OpticalBlack[4];
	//A030
	int32D5 ColorMatrixCameraSetting[9];
	//A031
	int32D5 ColorMatrixRGB[9];
	//A032
	int32D5 ColorMatrixAdobeRGB[9];
	//A033
	int32D5 CbCr_Matrix_Default[4];
	//A034
	int32D5 CbCr_Matrix_CameraSetting[4];
	//A035
	uint32D5 CbCr_Gain_Default[2];
	//A036
	uint32D5 CbCr_Gain_CameraSetting[2];
	//A040
	uint32D5 ToneCurve_Def_sRGB[23];
	//A041
	uint32D5 ToneCurve_Def_AdobeRGB[23];
	//A042
	uint32D5 ToneCurve_Camera_sRGB[23];
	//A043
	uint32D5 ToneCurve_Camera_AdobeRGB[23];
	//A048
	uint32D5 RawData[12];
	//A050
	int32D5 Distortion[8];
	//A051
	uint16D5 ChromaticAbberation[22];
	//A052
	uint16D5 LensShading[15];
	//A053
	uint16D5 LensShading_Cor[15];
	//A054
	uint16D5 LensShading_Set[15];
	//A055
	int32D5 DistortionCamera1st[8];
	//A056
	int32D5 DistortionCamera2nd[8];
	//A057
	int32D5 DistortionCameraSetting[8];
	//A060
	int32D5	CISTemperature[2];
	//A061
	uint16D5 Compression;
	
} MakerNoteParam;

typedef struct ExifIFDParam
{
	int EntryNumber;

	//8822
	uint16D5 ExposureProgram;
	//9000
	char ExifVersion[4];
	//9003
	char DateTimeOriginal[19];
	//9004
	char DateTimeDigitized[19];
	//9101
	uint32D5 ComponentsConfiguration;
	//9204
	int ExposureBiasValue[3];
	//9205
	uint32D5 MaxApertureValue[2];
	//9207
	uint16D5 MeteringMode;
	//9208
	uint16D5 LightSource;
	//920A
	uint32D5 FocalLength[3];
	//A000
	uint8D5 FlashpixVersion[4];
	//A001
	uint16D5 ColorSpace;
	//A002
	uint32D5 PixelXDimension;
	//A003
	uint32D5 PixelYDimension;
	//A005
	uint32D5 InteroperabilityIFDPointer;
	//A217
	uint16D5 SensingMethod;
	//A402
	uint16D5 ExposureMode;
	//A403
	uint16D5 WhiteBalance;
	//A404
	uint32D5 DigitalZoomRatio[3];
	//A405
	uint16D5 FocalLengthIn35;
	//A406
	uint16D5 SceneCaptureType;
	//A408
	uint16D5 Contrast;
	//A409
	uint16D5 Saturation;
	//A40A
	uint16D5 Sharpness;
	//A500
	uint32D5 Gamma[2];
	//829A
	uint32D5 ExposureTime[3];
	//829D
	uint32D5 FNumber[3];
	//8827
	short ISO;
	//9209
	short Flash;
	//A302
	uint16D5 CFAPattern;
	//927C
	uint32D5 MakerNoteOffset;


} ExifIFDParam;

typedef struct ZerothIFDParam
{
	int EntryNumber;
	//010F
	char MakerName[8];
	//0110
	char ModelName[14];
	//0112
	uint16D5 ImageOrientation;
	//0131
	char* SoftwareVersion;
	//0132
	char DateTime[19];
	//8769
	uint32D5 ExifOffset;
	//014A
	uint32D5 PrimaryJPEGIFD;
	//014A
	uint32D5 PrimaryRAWIFD;
	//014A
	uint32D5 SubIFD;
	//8825
	uint32D5 GPSIFD;
	uint32D5 NextIFD;
	//010E
	uint8D5 *ImageDescription;
	//011A
	uint32D5 XResolution[2];
	//011B
	uint32D5 YResolution[2];
	//0128
	uint16D5 ResolutionUnit;
	//0213
	uint16D5 YCbCrPositioning;
} ZerothIFDParam;

typedef struct PrimaryRAWIFDParam
{
	int EntryNumber;
	//00FE
	uint32D5 SubfileType;
	//0100
	uint32D5 ImageWidth;
	//0101
	uint32D5 ImageHeight;
	//0102
	uint16D5 BitsPerSample;
	//0103
	uint32D5 RawDataType;
	//0111
	uint32D5 StripOffsets; //Raw_stream_offset
	//0115
	uint16D5 SamplesPerPixel;
	//0116
	uint32D5 RowsPerStrip;
	//0117
	uint32D5 StripByteCounts; //Raw_stream_size
	//828D
	uint16D5 CFARepeatPatternDim[2];
	//828E
	uint32D5 CFAPattern2;
	//A010
	uint32D5 CompMapDataOffset; //Mmap_stream_offset;
	//A011
	uint32D5 CompMapDataSize; //Mmap_stream_size
	//A101
	uint16D5 RawDataEndian;
	//A102
	uint16D5 RawDataPaddingInfo;
} PrimaryRawIFDParam;

typedef struct PrimaryJPEGIFDParam
{
	int EntryNumber;
	//0100
	uint32D5 ImageWidth;
	//0101
	uint32D5 ImageLength;
	//0102
	uint16D5 BitsPerSample;
	//0103
	uint16D5 Compression;
	//0106
	uint16D5 PhotometricInterpretation;
	//010E
	uint8D5 *ImageDescription;
	//010F
	uint8D5 *Make;
	//0110
	uint8D5 *Model;
	//0111
	uint32D5 StripOffsets;
	//0112
	uint16D5 Orientation;
	//0115
	uint16D5 SamplesPerPixel;
	//0116
	uint32D5 RowsPerStrip;
	//0117
	uint32D5 StripByteCounts;
	//011A
	uint32D5 XResolution[2];
	//011B
	uint32D5 YResolution[2];
	//011C
	uint16D5 PlanarConfiguration;
	//0128
	uint16D5 ResolutionUnit;
	// 012D
	uint16D5 TransferFunction;
	//0131
	uint8D5 *Software;
	// 0132
	uint8D5 DateTime[20];
	//013B
	uint8D5 *Artist;
	//013E
	uint32D5 WhitePoint[2][2];
	//013F
	uint32D5 PrimaryChromaticities[2][6];
	//0201
	uint32D5 JPEGInterchangeFormat; // The offset to the start byte (SOI) of JPEG compressed thumbnail data. This shall not be used for primary image JPEG data.
	//0202
	uint32D5 JPEGInterchangeFormatLength; // The number of bytes of JPEG compressed thumbnail data. 
	//0211
	uint32D5 YCbCrCoefficients[2][3];
	//0212
	uint16D5 YCbCrSubSampling[2];
	//0213
	uint16D5 YCbCrPositioning;
	//0214
	uint32D5 ReferenceBlackWhite[2][6];
	//8298
	uint8D5 *Copyright;


} PrimaryJPEGIFDParam;

typedef struct ScreennailIFDParam
{
	int EntryNumber;
	//0100
	uint32D5 ImageWidth;
	//0101
	uint32D5 ImageLength;
	//0102
	uint16D5 BitsPerSample;
	//0103
	uint16D5 Compression;
	//0106
	uint16D5 PhotometricInterpretation;
	//010E
	uint8D5 *ImageDescription;
	//010F
	uint8D5 *Make;
	//0110
	uint8D5 *Model;
	//0111
	uint32D5 StripOffsets;
	//0112
	uint16D5 Orientation;
	//0115
	uint16D5 SamplesPerPixel;
	//0116
	uint32D5 RowsPerStrip;
	//0117
	uint32D5 StripByteCounts;
	//011A
	uint32D5 XResolution[2];
	//011B
	uint32D5 YResolution[2];
	//011C
	uint16D5 PlanarConfiguration;
	//0128
	uint16D5 ResolutionUnit;
	// 012D
	uint16D5 TransferFunction;
	//0131
	uint8D5 *Software;
	// 0132
	uint8D5 DateTime[20];
	//013B
	uint8D5 *Artist;
	//013E
	uint32D5 WhitePoint[2][2];
	//013F
	uint32D5 PrimaryChromaticities[2][6];
	//0201
	uint32D5 JPEGInterchangeFormat; // The offset to the start byte (SOI) of JPEG compressed thumbnail data. This shall not be used for primary image JPEG data.
	//0202
	uint32D5 JPEGInterchangeFormatLength; // The number of bytes of JPEG compressed thumbnail data. 
	//0211
	uint32D5 YCbCrCoefficients[2][3];
	//0212
	uint16D5 YCbCrSubSampling[2];
	//0213
	uint16D5 YCbCrPositioning;
	//0214
	uint32D5 ReferenceBlackWhite[2][6];
	//8298
	uint8D5 *Copyright;


} ScreennailIFDParam;

typedef struct RefCheck
{
	char IFD_Name[10];
	char Tag_Name[30];
	char Check[6];
	char Tag_ID[5];
	char default_SRW[2];	// mandatory, optional, recommend, not allowed, etc
	char default_JPG[2];
	char result[3];		// verification result
} RefCheck;

typedef struct GPSIFDParam
{
	//0000
	uint8D5 GPSVersionID[4];
	//0001
	uint8D5 GPSLatitudeRef[2];
	// 0002
	uint32D5 GPSLatitude[2][3];
	//0003
	uint8D5 GPSLongitudeRef[2];
	//0004
	uint32D5 GPSLongitude[2][3];
	//0005
	uint8D5 GPSAltitudeRef;
	//0006
	uint32D5 GPSAltitude[2];
	//0007
	uint32D5 GPSTimeStamp[2][3];
	//0008
	uint8D5 *GPSSatellites;
	//0009
	uint8D5 GPSStatus[2];
	//000A
	uint8D5 GPSMeasureMode[2];
	//000B
	uint32D5 GPSDOP[2];
	//000C
	uint8D5 GPSSpeedRef[2];
	//000D
	uint32D5 GPSSpeed[2];
	//000E
	uint8D5 GPSTrackRef[2];
	//000F
	uint32D5 GPSTrack[2];
	//0010
	uint8D5 GPSImgDirectionRef[2];
	//0011
	uint32D5 GPSImgDirection[2];
	//0012
	uint8D5 *GPSMapDatum;
	//0013
	uint8D5 GPSDestLatitudeRef[2];
	//0014
	uint32D5 GPSDestLatitude[2][3];
	//0015
	uint8D5 GPSDestLongitudeRef[2];
	//0016
	uint32D5 GPSDestLongitude[2][3];
	//0017
	uint8D5 GPSDestBearingRef[2];
	//0018
	uint32D5 GPSDestBearing[2];
	//0019
	uint8D5 GPSDestDistanceRef[2];
	//001A
	uint32D5 GPSDestDistance[2];
	//001B
	uint8D5 *GPSProcessingMethod;
	//001C
	uint8D5 *GPSAreaInformation;
	//001D
	uint8D5 GPSDateStamp[11];
	//001E
	uint16D5 DPSDifferential;
	//001F
	uint32D5 GPSHPositioningError[2];

} GPSIFDParam;

typedef struct FirstIFDParam
{
	int EntryNumber;
	//0100
	uint32D5 ImageWidth;
	//0101
	uint32D5 ImageLength;
	//0102
	uint16D5 BitsPerSample;
	//0103
	uint16D5 Compression;
	//0106
	uint16D5 PhotometricInterpretation;
	//010E
	uint8D5 *ImageDescription;
	//010F
	uint8D5 *Make;
	//0110
	uint8D5 *Model;
	//0111
	uint32D5 StripOffsets;
	//0112
	uint16D5 Orientation;
	//0115
	uint16D5 SamplesPerPixel;
	//0116
	uint32D5 RowsPerStrip;
	//0117
	uint32D5 StripByteCounts;
	//011A
	uint32D5 XResolution[2];
	//011B
	uint32D5 YResolution[2];
	//011C
	uint16D5 PlanarConfiguration;
	//0128
	uint16D5 ResolutionUnit;
	// 012D
	uint16D5 TransferFunction;
	//0131
	uint8D5 *Software;
	// 0132
	uint8D5 DateTime[20];
	//013B
	uint8D5 *Artist;
	//013E
	uint32D5 WhitePoint[2][2];
	//013F
	uint32D5 PrimaryChromaticities[2][6];
	//0201
	uint32D5 JPEGInterchangeFormat; // The offset to the start byte (SOI) of JPEG compressed thumbnail data. This shall not be used for primary image JPEG data.
	//0202
	uint32D5 JPEGInterchangeFormatLength; // The number of bytes of JPEG compressed thumbnail data. 
	//0211
	uint32D5 YCbCrCoefficients[2][3];
	//0212
	uint16D5 YCbCrSubSampling[2];
	//0213
	uint16D5 YCbCrPositioning;
	//0214
	uint32D5 ReferenceBlackWhite[2][6];
	//8298
	uint8D5 *Copyright;

} FirstIFDParam;

typedef struct MPEntry
{
	uint32D5 ImageAttrinute;
	uint32D5 ImageSize;
	uint32D5 ImageOffset;
	uint16D5 DepImg1Num;
	uint16D5 DepImg2Num; 
}MPEntry;

typedef struct MPExtensionParam
{	
	int EntryNumber;
	//B000
	uint32D5 MPFVersion;
	//B001
	uint32D5 NumberOfImage;
	//B002
	MPEntry mpEntry1;
	MPEntry mpEntry2;
	//B003
	uint8D5 ImageUIDList[3][33];
	//B004
	uint32D5 TotalFrames;	
	// Next IFD
	uint32D5 NextIFD;
} MPExtensionParam;

typedef struct MetaDataParam
{
	MakerNoteParam makernote;
	ExifIFDParam exifIFD;
	ZerothIFDParam  zerothIFD;
	PrimaryRawIFDParam primaryraw;
	RefCheck reference[TagNum];
	GPSIFDParam gps;
	FirstIFDParam first;
	PrimaryJPEGIFDParam primaryjpeg;
	ScreennailIFDParam screennail;
	MPExtensionParam app2;
} MetaDataParam;

#endif
