#include "M7MuCodec.h"
#include <iostream>

unsigned long M7Codec::getnFileSize()
{
	return nFileSize;
}
unsigned long M7Codec::getnRealFileSize()
{
	return nRealFileSize;
}

bool M7Codec::M7MuDecoding(const char *path)
{		
	FILE *f;
	fopen_s(&f, path, "rb");
	if( !f )
	{
		ReturnFlag=1;
		return false;
	}
	
	if( fseek(f, 0L, SEEK_END) != 0 )
	{
		ReturnFlag=1;
		return false;
	}	
	int sz = ftell(f);
	if( sz <= 0 )
	{
		ReturnFlag=1;
		return false;
	}	
	nFileSize = sz;
	ExtStrBuf = new BYTE[nFileSize];	

	if( fseek(f, 0L, SEEK_SET)  != 0 )
	{
		delete ExtStrBuf;
		return false;
	}

	int freadVal = fread(ExtStrBuf, 1, nFileSize, f);
	if( freadVal < 1 )
	{	
		delete ExtStrBuf;;
		return false;	
	}
	
	if( fclose(f) != 0 )
	{
		delete ExtStrBuf;
		return false;
	}
	
	RawParsing();  //Compressed Raw
	
	if(ReturnFlag==1)
	{
		delete ExtStrBuf;
		return false;
	}
	
	nFileSize = (unsigned long)(ImgWidth*ImgHeight*1.5);  //Raw Width X Raw Height X 12Bits	
	nRealFileSize = ImgWidth * ImgHeight;  //Raw Width X Raw Height
	ExtStrBufOri = new unsigned char[nFileSize];  //Original Value
	ExtStrBufOri2 = new short[(unsigned long)(ImgWidth*ImgHeight*2)];  //Original Value2 12bit unpack
	ExtStrBuf12Bits = new short[nRealFileSize];  //12Bits Value
	
	BitCount = 0;
	pByte = &m_pBuf[0];
	RawDec();
	
	InvDpcmRaw();

	delete ExtStrBuf;
	delete m_pBuf;
	delete ExtStrBufOri;
	delete ExtStrBufOri2;

	return true;
}

void M7Codec::RawParsing()
{
	int idx01, idx02, count01, count02, IFD_entry_num01, IFD_entry_num02;
	int tag_id, tag_type, tag_offset, raw_bit;
	int model_mini;
	int model_3000;
	unsigned IFD_offset, Img_offsetRaw, nFileSizeRaw, buf_count;

	buf_count=0;
	buf_count = 7;  //Endian Type + Endian Type confirmation + First Address skip

	IFD_entry_num01=*(ExtStrBuf+(buf_count+2))<<8;
	IFD_entry_num01+=*(ExtStrBuf+(buf_count+1));
	buf_count = buf_count + 2;

	count01=0;
	for(idx01=0; idx01<IFD_entry_num01; idx01++)
	{
		tag_id=*(ExtStrBuf+(buf_count+2))<<8;
		tag_id+=*(ExtStrBuf+(buf_count+1));

		if(tag_id==0x0110 || tag_id==0x014A)  //DSC model or SubIFD/DataOffset
		{
			switch(tag_id)
			{
			case 272:  //DSC Model (0x0110)
				tag_offset =*(ExtStrBuf+(buf_count+12))<<24;  //DSC Model Tag Offset
				tag_offset+=*(ExtStrBuf+(buf_count+11))<<16;  //DSC Model Tag Offset
				tag_offset+=*(ExtStrBuf+(buf_count+10))<<8;  //DSC Model Tag Offset
				tag_offset+=*(ExtStrBuf+(buf_count+9));  //DSC Model Tag Offset				

				//NX mini Model Character Recognition // NX3000
				model_3000 = 0;
				model_mini = 0;

				model_3000 = (*(ExtStrBuf+(tag_offset)) == 0x4E) && (*(ExtStrBuf+(tag_offset+1)) == 0x58) && (*(ExtStrBuf+(tag_offset+2)) == 0x33) && (*(ExtStrBuf+(tag_offset+3)) == 0x30) && (*(ExtStrBuf+(tag_offset+4)) == 0x30) && (*(ExtStrBuf+(tag_offset+5)) == 0x30) && (*(ExtStrBuf+(tag_offset+6)) == 0x00) && (*(ExtStrBuf+(tag_offset+7)) == 0x00);
				model_mini = (*(ExtStrBuf+(tag_offset)) == 0x4E) && (*(ExtStrBuf+(tag_offset+1)) == 0x58) && (*(ExtStrBuf+(tag_offset+2)) == 0x20) && (*(ExtStrBuf+(tag_offset+3)) == 0x6D) && (*(ExtStrBuf+(tag_offset+4)) == 0x69) && (*(ExtStrBuf+(tag_offset+5)) == 0x6E) && (*(ExtStrBuf+(tag_offset+6)) == 0x69) && (*(ExtStrBuf+(tag_offset+7)) == 0x00);			
				break;

			case 330:  //SubIFD/DataOffset (0x014A)
				tag_offset = *(ExtStrBuf+(buf_count+12))<<24;  //SubIFD/DataOffset Offset
				tag_offset+=*(ExtStrBuf+(buf_count+11))<<16;  //SubIFD/DataOffset Offset
				tag_offset+=*(ExtStrBuf+(buf_count+10))<<8;  //SubIFD/DataOffset Offset
				tag_offset+=*(ExtStrBuf+(buf_count+9));  //SubIFD/DataOffset Offset	

				buf_count = tag_offset;
						
				IFD_offset = *(ExtStrBuf+(buf_count+7))<<24;  //Primary Raw IFD Offset
				IFD_offset+=*(ExtStrBuf+(buf_count+6))<<16;  //Primary Raw IFD Offset
				IFD_offset+=*(ExtStrBuf+(buf_count+5))<<8;  //Primary Raw IFD Offset
				IFD_offset+=*(ExtStrBuf+(buf_count+4));  //Primary Raw IFD Offset

				buf_count = IFD_offset;

				IFD_entry_num02=*(ExtStrBuf+(buf_count+1))<<8;  //Primary Raw IFD Entry Number
				IFD_entry_num02+=*(ExtStrBuf+(buf_count));  //Primary Raw IFD Entry Number

				buf_count = buf_count + 1;  //Primary Raw IFD Element No.
				count02=0;
				for(idx02=0; idx02<IFD_entry_num02; idx02++)
				{
					tag_id=*(ExtStrBuf+(buf_count+2))<<8;
					tag_id+=*(ExtStrBuf+(buf_count+1));

					if(tag_id==0x0100 || tag_id==0x0101 || tag_id==0x0102 || tag_id==0x0111 || tag_id==0x0117)  //Image Width, Image Height, BitsPerSample, Compression, Raw Data Offset, Raw Data Size.
					{
						switch(tag_id)
						{
						case 256:  //Image Width (0x0100) => Type: Short Integer
							tag_type=*(ExtStrBuf+(buf_count+4))<<8;
							tag_type+=*(ExtStrBuf+(buf_count+3));

							if(tag_type==3)  //Short Integer
							{	
								ImgWidth=*(ExtStrBuf+(buf_count+10))<<8;  //Raw Width
								ImgWidth+=*(ExtStrBuf+(buf_count+9));  //Raw Width								
							}

							else if(tag_type==4)  //Long Integer
							{	
								ImgWidth = *(ExtStrBuf+(buf_count+12))<<24;  //Raw Width
								ImgWidth+=*(ExtStrBuf+(buf_count+11))<<16;  //Raw Width
								ImgWidth+=*(ExtStrBuf+(buf_count+10))<<8;  //Raw Width
								ImgWidth+=*(ExtStrBuf+(buf_count+9));  //Raw Width
							}
							break;

						case 257:  //Image Height (0x0101)
							tag_type=*(ExtStrBuf+(buf_count+4))<<8;
							tag_type+=*(ExtStrBuf+(buf_count+3));

							if(tag_type==3)  //Short Integer
							{	
								ImgHeight=*(ExtStrBuf+(buf_count+10))<<8;  //Raw Height
								ImgHeight+=*(ExtStrBuf+(buf_count+9));  //Raw Height								
							}

							else if(tag_type==4)  //Long Integer
							{	
								ImgHeight = *(ExtStrBuf+(buf_count+12))<<24;  //Raw Height
								ImgHeight+=*(ExtStrBuf+(buf_count+11))<<16;  //Raw Height
								ImgHeight+=*(ExtStrBuf+(buf_count+10))<<8;  //Raw Height
								ImgHeight+=*(ExtStrBuf+(buf_count+9));  //Raw Height
							}
							break;

						case 258:  //BitsPerSample (0x0102)
							raw_bit = 12;  //SAMSUNG NX300 SRW File
							break;

						case 273:  //Primary Raw Stream Offset (0x0111)
							Img_offsetRaw = *(ExtStrBuf+(buf_count+12))<<24;  //Primary Raw Stream Offset
							Img_offsetRaw+=*(ExtStrBuf+(buf_count+11))<<16;  //Primary Raw Stream Offset
							Img_offsetRaw+=*(ExtStrBuf+(buf_count+10))<<8;  //Primary Raw Stream Offset
							Img_offsetRaw+=*(ExtStrBuf+(buf_count+9));  //Primary Raw Stream Offset
							break;
							
						case 279:  //Primary Raw Stream Size (0x0117)
							nFileSizeRaw = *(ExtStrBuf+(buf_count+12))<<24;  //Primary Raw Stream Size
							nFileSizeRaw+=*(ExtStrBuf+(buf_count+11))<<16;  //Primary Raw Stream Size
							nFileSizeRaw+=*(ExtStrBuf+(buf_count+10))<<8;  //Primary Raw Stream Size
							nFileSizeRaw+=*(ExtStrBuf+(buf_count+9));  //Primary Raw Stream Size
							break;
						}
						buf_count = buf_count + 12;
					}

					else
					{
						buf_count = buf_count + 12;
						count02++;
					}
				}

				if(count02 == IFD_entry_num02)
				{
					ReturnFlag=1;
					return;
				}
				break;
			}
			buf_count = buf_count + 12;
		}

		else
		{
			buf_count = buf_count + 12;
			count01++;
		}
	}

	if(count01 == IFD_entry_num01)
	{
		ReturnFlag=1;
		return;
	}

	m_pBuf = new BYTE[nFileSizeRaw];
	memcpy(m_pBuf, &ExtStrBuf[Img_offsetRaw], nFileSizeRaw);
}

void M7Codec::RawDec()
{
	std::cout << "RawDec() 1" << std::endl;
	unsigned i;
	int j, Value;
	WORD CODE;
	BOOL temp;
	std::cout << "RawDec() 2" << std::endl;
	for(i=0; i<nRealFileSize; i++)
	{
		j = 1;
		CODE = NextBit();
		temp=FALSE;

		while(temp==FALSE)
		{
			CODE = (CODE << 1) + NextBit();
			j++;

			temp = (j==2 && (CODE==0x1 || CODE==0x2)) || (j==3 && (CODE==0x0 || CODE==0x1)) || (j==4 && (CODE==0xC || CODE==0xE || CODE==0xF)) || (j==5 && CODE==0x1B) ||
                   (j==6 && CODE==0x34) || (j==7 && CODE==0x6A) || (j==8 && CODE==0xD6) || (j==9 && CODE==0x1AE) || (j==10 && CODE==0x35E);
		}
		Value = BitCpr(j*CODE);
		ExtStrBuf12Bits[i] = Extend(Value);
		//std::cout << "RawDec() 2-1  %d " << i << std::endl;
	}
	std::cout << "RawDec() 3" << std::endl;
}

int M7Codec::BitCpr(WORD CODES)
{
	switch(CODES)
	{
	case 0x0:
		return 4;
		break;

	case 0x2:
		return 6;
		break;

	case 0x3:
		return 7;
		break;

	case 0x4:
		return 5;
		break;

	case 0x30:
		return 3;
		break;

	case 0x38:
		return 8;
		break;

	case 0x3C:
		return 2;
		break;

	case 0x87:
		return 1;
		break;

	case 0x138:
		return 0;
		break;

	case 0x2E6:
		return 9;
		break;

	case 0x6B0:
		return 10;
		break;

	case 0xF1E:
		return 11;
		break;

	case 0x21AC:
		return 12;
		break;
	}
	return -1;
}

WORD M7Codec::NextBit()
{
	WORD Bit;
	static BYTE B;

	if(BitCount == 0)
	{
		B = *(pByte++);
		BitCount = 8;
	}

	Bit = B >> 7;
	BitCount--;
	B = B << 1;

	return Bit;
}

short M7Codec::Extend(BYTE T)
{
	BYTE i = 0;
	WORD V = 0;
	while(i != T)
	{
		i++;
		V = (V << 1) + NextBit();
	}
	
	WORD Vt = 1 << (T-1);
	if( V < Vt )
	{
		Vt = (-1 << T) + 1;
		V = V + Vt;
	}
	return (short)V;
}

void M7Codec::InvDpcmRaw()
{
	int i, j;
	unsigned buf;

	//Bayer Channel Inverse DPCM
	for(j=0; j<ImgHeight; j++)
	{
		if(j>1)
		{
			ExtStrBuf12Bits[j*ImgWidth] = ExtStrBuf12Bits[j*ImgWidth] + ExtStrBuf12Bits[(j*ImgWidth)-(ImgWidth*2)];
			ExtStrBuf12Bits[(j*ImgWidth)+1] = ExtStrBuf12Bits[(j*ImgWidth)+1] + ExtStrBuf12Bits[((j*ImgWidth)+1)-(ImgWidth*2)];
		}

		for(i=2; i<ImgWidth; i++)
			ExtStrBuf12Bits[i+(j*ImgWidth)] = ExtStrBuf12Bits[i+(j*ImgWidth)] + ExtStrBuf12Bits[(i+(j*ImgWidth))-2];
	}
}