#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include "Decoder.h"
#include "define.h"


#define ON	1
#define OFF	0
#define RECON_FILE_DUMP ON



int main(int argc, char *argv[])
{
	unsigned char *pReconBuff;
	unsigned char *pReconBuffPack;
	int nImgWidth, nImgHeight;

	//argv[1] = "C:\\Users\\SEC\\Desktop\\NX1_0707\\image1.SRW";
	//argv[1] = "C:\\Users\\SEC\\Desktop\\test\\SAM_0566.SRW";
	argv[1] = "C:\\Users\\SEC\\Desktop\\NX1_0828\\14\\SAM_0442.SRW";
	argc = 2;
	// version

	printf("# SRW LRC Decoder v3.0 (for DRIMe5)#\n");

	// check argument
	if(argc<2)
	{		
		//printf("Usage: %s [input bit-stream filename]\n", argv[0]);
		printf("Usage: %s [input SRW filename]\n", argv[0]);
		printf("Release Code: 20140710A\n");
		exit(-1);
	}

	// Memory Allocation for Recon
	pReconBuff = (unsigned char *)malloc(8192*8192*sizeof(unsigned short));	//16bit per cc
	pReconBuffPack = (unsigned char *)malloc(8192*8192*sizeof(unsigned short));	//16bit per cc
	
	DecoderParam dp;
	MetaDataParam mp;

	memset(&mp, 0, sizeof(MetaDataParam));	
	setMP(&mp);

	//Ķ ʱȭ
	IntializeDecoderParam(&dp);
	//dp._bitstream = (uint32D5 *)pStream;
	bitstream_init(&dp);
	FileIOInit(&dp, argv[1]);

	SrwParse(&dp, &mp);
	
	//////////////////////////////////////////////////////////////////////////////////////
	
	if(LRC_Decode(&dp, pReconBuff, &nImgWidth, &nImgHeight))
	{
		printf("Decoding Error!!\n");
		return 0;
	}

	//////////////////////////////////////////////////////////////////////////////////////	

	std::cout << "BitsPerSample = " << mp.primaryraw.BitsPerSample <<"bit"<< std::endl;
	//printf(" BitsPersample %d \n", mp.primaryraw.BitsPerSample);


	// Recon file Dump
	//DumpRecon(pReconBuff, nImgWidth*nImgHeight);
	FILE *fp;
	char fileNamePack[100];
	char fileNameUnPack[100];	
	char *fileNameTemp;
	
	fileNameTemp = (char*)malloc(strlen(argv[1]) + 1);
	strcpy(fileNameTemp, argv[1]);
	
	int inputFileNameSize = strlen(fileNameTemp);
	fileNameTemp[inputFileNameSize-1] = '\0';
	fileNameTemp[inputFileNameSize-2] = '\0';
	fileNameTemp[inputFileNameSize-3] = '\0';
	fileNameTemp[inputFileNameSize-4] = '\0';
	char *addPack12Name = "_Pack12bit.raw";
	char *addUnPack12Name = "_UnPack12bit.raw";
	char *addPack14Name = "_Pack14bit.raw";
	char *addUnPack14Name = "_UnPack14bit.raw";
	inputFileNameSize = strlen(fileNameTemp);


	//unpack -> pack reordering	
	int index = 0;
	int idx = 0;
	unsigned long nSize;

	// 12bit
	if( mp.primaryraw.BitsPerSample == 12 )
	{
		nSize = nImgWidth*nImgHeight*1.5;
		for(int i = 0; i < nSize; i+=3)
		{	
			pReconBuffPack[i] = pReconBuff[idx];
			pReconBuffPack[i+1] = (pReconBuff[idx+1] & 0x0F) + ((pReconBuff[idx+2] & 0x0F) << 4);
			pReconBuffPack[i+2] = ((pReconBuff[idx+3] & 0x0F) << 4) + ((pReconBuff[idx+2] & 0xF0) >> 4);

			idx = idx + 4;				
		}
		//std::cout << " nSize = " << nSize << std::endl;
		//std::cout << " idx = " << idx << std::endl;
		//dump pack unpack data
		strcpy(fileNamePack, fileNameTemp);
		strcat(fileNamePack, addPack12Name);
		strcpy(fileNameUnPack, fileNameTemp);
		strcat(fileNameUnPack, addUnPack12Name);
		fp = fopen(fileNameUnPack, "wb");
		if(fp==NULL) { printf("file open error\n"); exit(-1); }
		fwrite(pReconBuff, nImgWidth*nImgHeight, 2, fp);
		fclose(fp);

		fp = fopen(fileNamePack, "wb");
		if(fp==NULL) { printf("file open error\n"); exit(-1); }
		fwrite(pReconBuffPack, nSize, 1, fp);
		fclose(fp);

	}
	else if( mp.primaryraw.BitsPerSample == 14 )
	{
		nSize = nImgWidth*nImgHeight*1.75;
		//unpack -> pack reordering(14bit)	
		for(int i = 0; i < nSize; i+=7)
		{
			pReconBuffPack[i] = pReconBuff[idx];
			pReconBuffPack[i+1] = (pReconBuff[idx+1] & 0x3F) + ((pReconBuff[idx+2] & 0x03) << 6);
			pReconBuffPack[i+2] = ((pReconBuff[idx+2] & 0xFC) >> 2) + ((pReconBuff[idx+3] & 0x03) << 6);
			pReconBuffPack[i+3] = ((pReconBuff[idx+3] & 0x3C) >> 2) + ((pReconBuff[idx+4] & 0x0F) << 4);
			pReconBuffPack[i+4] = ((pReconBuff[idx+4] & 0xF0) >> 4) + ((pReconBuff[idx+5] & 0x0F) << 4);
			pReconBuffPack[i+5] = ((pReconBuff[idx+5] & 0x30) >> 4) + ((pReconBuff[idx+6] & 0x3F) << 2);
			pReconBuffPack[i+6] = ((pReconBuff[idx+6] & 0xC0) >> 6) + ((pReconBuff[idx+7] & 0x3F) << 2);

			idx = idx + 8;
		}
		//std::cout << " nSize = " << nSize << std::endl;
		//std::cout << " idx = " << idx << std::endl;
		//dump pack unpack data
		strcpy(fileNamePack, fileNameTemp);
		strcat(fileNamePack, addPack14Name);
		strcpy(fileNameUnPack, fileNameTemp);
		strcat(fileNameUnPack, addUnPack14Name);
		fp = fopen(fileNameUnPack, "wb");
		if(fp==NULL) { printf("file open error\n"); exit(-1); }
		fwrite(pReconBuff, nImgWidth*nImgHeight, 2, fp);
		fclose(fp);

		fp = fopen(fileNamePack, "wb");
		if(fp==NULL) { printf("file open error\n"); exit(-1); }
		fwrite(pReconBuffPack, nSize, 1, fp);
		fclose(fp);
	}

	// Memory Deallocation		
	free(fileNameTemp);
	free(pReconBuff);
	free(pReconBuffPack);
	/**/
	return 0;
}